! Mdulo zn.h 2.1 para InformatE 6/7E o 6/10E
! (C) 2000,2001 El Presi (Enrique D. Bosch) [kifcu@confluencia.net]
! Puede distribuirse libremente bajo licencia GNU LGPL
!
! aade extensin a la orden 'z' o 'esperar' de modo que despus
! de esta se puede especificar el nmero de turnos que quieres
! que pasen ej: 'z 10' hace que pasen 10 turnos de una tacada
!
! la versin 2.0 aade espera de tiempo entre turno y turno
! y posibilidad de detener la espera pulsando una tecla
! (modo interactivo), a peticin del Clrigo Urbatain
!
! en la versin 2.1 se actualiza la barra de estado en cada
! turno en el modo interactivo
!
! debe incluirse despus de Gramatica.h
!
! se pueden redefinir en el programa principal las propierdades del
! objeto zn_conf:
!
! zn_conf.tiempo         es el tiempo de espera en dcimas de
!                        segundo entre turno y turno, por defecto
!                        es cero
! zn_conf.parar          puede ser 'true' o 'false', indica si
!                        se debe permitir que al pulsar una tecla
!                        se aborte la accin esperar, por defecto
!                        es false
! zn_conf.no_barra       puede ser 'true' o 'false', desactiva la
!                        barrita de actividad, por defecto activada
! zn_conf.max_turnos     es el nmero mximo de turnos que se pueden
!                        esperar

message "Modulo zn 2.1 de El Presi";

system_file;

#ifndef WORDSIZE;
constant WORDSIZE=2;
constant TARGET_ZCODE;
#endif;

constant ZN_PRESENTE;


object zn_conf
  with
     tiempo 0,
     parar false,
     no_barra false,
     max_turnos 9999;     ! 10000 son los maximos que permite Inform, si se
                          ! pone mas se devuelve 10000, asi que para
                          ! detectarlo el maximo es 9999

extend 'z//'
* number           ->  zn
* number 'turnos'  ->  zn
* number 'turno'   ->  zn;


[ znsub i k x;
  
  if (uno>zn_conf.max_turnos)
    {
      zn_msg(1);   ! no se puede
      return;
    }  
  if (zn_conf.tiempo==0)  ! modo tiempo de esperar cero
    {
      zn_msg(2);     ! mensaje pasa tiempo
#ifdef TARGET_ZCODE;     ! fuerza un volcado del bufer de texto de salida
      @read_char 1 1 zn_true k;
#ifnot;
      glk($00D6, 1); ! request_timer_events
      glk($00C0, gg_arguments); ! glk_select(gg_arguments);
      glk($00D6, 0); ! request_timer_events (cancelados)
#endif;
      for (i=1: i<uno: i++) LibreriaInform.secuencia_fin_turno();
    }
  else                        ! modo interactivo
    {
      zn_msg(3);              ! mensaje pasa tiempo
      x=zn_conf.tiempo;
      for (i=1: i<uno: i++) 
       {
#ifdef TARGET_ZCODE;
         @read_char 1 x zn_true k;
#ifnot;
         glk($00D6, x*100); ! request_timer_events
         glk($00D2, gg_mainwin); ! glk_request_char_event(gg_mainwin);
         while(1) 
          {
            glk($00C0, gg_arguments); ! glk_select(gg_arguments);
            if ((gg_arguments-->0) == 2)  ! 2=evType_CharInput
              { 
                k=1;
                break;
              }
            if ((gg_arguments-->0) == 1)
             {
               glk($00D3, gg_mainwin); ! cancel_char_event
               glk($00D6, 0); ! request_timer_events (cancelados)
               k=0;
               break;
             }
          }
#endif;
         LibreriaInform.secuencia_fin_turno();
         dibujarlineaestado();
         if (k && zn_conf.parar) break;
         zn_msg(4,i);   ! mensaje pasa tiempo con [o sin] barrita
       }
    }
];


[ zn_true; return true; ];


[ zn_barrita x;

  if (zn_conf.no_barra) return;
  switch (x%4)
    {
      0: print "-";
      1: print "@@92";
      2: print "|";
      3: print "/";
    }
];


[ zn_msg m i;

  if (~~tate_callao)
    switch(m)
      {
        1:print "No se puede esperar tanto.^";
        2:print "Pasa algn tiempo...^";
        3:print "^Pasa un instante de tiempo...^";
        4:print "^Pasa otro instante de tiempo...",(zn_barrita) i, "^";
      }
];
